/*  */

      #include <windows.h>

      LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);

      void MsgBoxi(HWND,LPCSTR,LPCSTR);

      HANDLE hInstance;                                 // global instance handle
      HANDLE hWnd;                                      // global main window handle
      HICON  hIcon;                                     // global icon handle
      HANDLE hMenu;                                     // global menu handle

/*  */

void main()

    {
      LPMSG         pmsg;                               // pointer for MSG structure
      WNDCLASSEX *  pwc;                                // pointer to WNDCLASSEX structure
      MSG           msg;                                // local msg structure
      WNDCLASSEX    wc;                                 // local structure for RegisterClassEx
      int           wid;
      int           hgt;
      int           Sw;
      int           Sh;
      char          szTitle[]       = "Microsoft C Template";
      char          szWindowClass[] = "C_Template";

   /* -----------------------------------
      get the application instance handle
      ----------------------------------- */
      hInstance = GetModuleHandle(NULL);

   /* ------------------------------------
      Copy structure addresses to pointers
      ------------------------------------ */
      pmsg = &msg;                                      // pointer to MSG struct
      pwc  = &wc;                                       // pointer to WNDCLASSEX struct

      hIcon = LoadIcon(hInstance,(LPCTSTR)5);           // load resource icon

      wc.cbSize           = sizeof(WNDCLASSEX); 
      wc.style            = CS_BYTEALIGNWINDOW | CS_BYTEALIGNCLIENT;
      wc.lpfnWndProc      = (WNDPROC)WndProc;
      wc.cbClsExtra       = 0;
      wc.cbWndExtra       = 0;
      wc.hInstance        = hInstance;
      wc.hIcon            = hIcon;
      wc.hCursor          = LoadCursor(NULL, IDC_ARROW);
      wc.hbrBackground    = (HBRUSH)(COLOR_WINDOW+1);
      wc.lpszMenuName     = NULL;
      wc.lpszClassName    = szWindowClass;
      wc.hIconSm          = hIcon;

      RegisterClassEx(pwc);      

      Sw = GetSystemMetrics(SM_CXSCREEN);              // screen width
      Sh = GetSystemMetrics(SM_CYSCREEN);              // screen height

      wid = Sw * .70;
      hgt = Sh * .70;

   /* ----------------------------------
      limit the aspect ratio to 1.4 to 1
      ---------------------------------- */
      if (wid > hgt * 1.4)
        {
        wid = hgt * 1.4;
        }

      hWnd = CreateWindowEx(WS_EX_LEFT,
                            szWindowClass,
                            szTitle,
                            WS_OVERLAPPEDWINDOW,
                            Sw/2-wid/2,
                            Sh/2-hgt/2,
                            wid,hgt,
                            NULL,NULL,hInstance,NULL);


      hMenu = LoadMenu(hInstance,(LPCTSTR)10);
      SetMenu(hWnd,hMenu);

      ShowWindow(hWnd,SW_SHOW);
      UpdateWindow(hWnd);

      while (GetMessage(pmsg,NULL,0,0))
        {
        switch (msg.message)
          {
          case WM_KEYUP:
            {
            switch (msg.wParam)
              {
              case VK_F1:
                {
                  MsgBoxi(hWnd,"You pressed the F1 key","Howdy");
                  break;
                }

              case VK_F2:
                {
                  MsgBoxi(hWnd,"You pressed the F2 key","Howdy");
                  break;
                }
              }
            }
          }
        TranslateMessage(pmsg);
        DispatchMessage(pmsg);
        }

    }

/*  */

LRESULT CALLBACK WndProc(HWND hWin,UINT uMsg,WPARAM wParam,LPARAM lParam)

  {
      switch (uMsg) 
      {
        case WM_COMMAND:
        {
        switch (wParam)
          {
            case 1010:
              {
                MsgBoxi(hWnd,"Open File","Howdy");
                break;
              }

            case 1020:
              {
                MsgBoxi(hWnd,"Save File","Howdy");
                break;
              }

            case 1090:
              {
                SendMessage(hWnd,WM_SYSCOMMAND,SC_CLOSE,(LPARAM)NULL);
                break;
              }

            case 5000:
              {
                MsgBoxi(hWnd,"C template using MSVCRT from VC98","About C Template");
                break;
              }
          }
        break;
        }

        case WM_CLOSE:
          break;

        case WM_DESTROY:
          PostQuitMessage(0);
          break;
      }

    return DefWindowProc(hWin,uMsg,wParam,lParam);

  }

/*  */

void MsgBoxi(HWND hWin,LPCSTR tMsg,LPCSTR ttl)

  {
      MSGBOXPARAMS mbp;

      mbp.cbSize            = sizeof(MSGBOXPARAMS);
      mbp.hwndOwner         = hWin;
      mbp.hInstance         = hInstance;
      mbp.lpszText          = tMsg;
      mbp.lpszCaption       = ttl;
      mbp.dwStyle           = MB_OK | MB_USERICON;
      mbp.lpszIcon          = MAKEINTRESOURCE(5);
      mbp.dwContextHelpId   = 0;
      mbp.lpfnMsgBoxCallback = NULL;
      mbp.dwLanguageId      = 0;

      MessageBoxIndirect(&mbp);
  }

/*  */










